#!/usr/bin/env node

import fs from 'fs'
import inquirer from 'inquirer'
import path from 'path'
// console.log('vue.js')
// console.log('fs')
// console.log(fs)

const destDir = process.cwd()

// 获取命令后所跟的文件名称
const file = process.argv[2]
if (!file) {
    console.log('请输入组件名称')
}

// 如果用户输入里目录地址，例如src/test/test，根据目录地址获取文件名
let vueName = file.slice(file.lastIndexOf('/') + 1, file.length)
let fileUrl = file + '.vue'
// 如果用户只输入了用户名称则将文件建在src/views文件夹下
if (fileUrl.indexOf('/') < 0) {
    fileUrl = 'src/views/' + fileUrl
}
let fileArr = fileUrl.split('/')
// 创建文件时使用，vueName可在模板文件中使用，区别为后缀名称
let fileName = vueName + '.vue'

let str = '你的模板文件'

inquirer.prompt([
    {
        type: 'input',
        name: 'isWriteRouter',
        message: '是否添加到路由？Y or N' // 根据用户输入来判断是否需要写入路由
    }
]).then((answers) => {
    console.log('fileUrl')
    console.log(fileUrl)
    mkdir(fileUrl)
    if (!fs.existsSync(fileUrl)) {
        // 创建文件，将模板文件写到文件内
        fs.writeFile(fileUrl, str, (err) => {
            if (err) throw err
            // 如果需要创建路由则调用路由方法
            if (answers.isWriteRouter.toLowerCase() === 'y') {
                writerRouter()
            }
        })
    } else {
        console.log('文件名已存在')
    }
})

function writerRouter() { // 异步读取文件
    new Promise((resolve, reject) => {
        fs.readFile(destDir + '/src/router/index.js', 'utf-8', (err, routerConfig) => {
            // routerConfig为读取到的路由文件的字符串
            if (err) throw err
            let [start, end] = routerConfig.split(']')
            // 将要添加的字符串拼接到现有的router内
            let totalString = `${start}\t\t{
                path: '/${fileName}',
                name: '${fileName}',
                component: () => import('@${fileUrl}')
            },\n] ${end}`
            resolve(totalString)
        })
    }).then(
        totalString => {
            // 写入拼接好的字符串
            fs.writeFile(destDir + '/src/router/index.js', totalString, (err) => {
                if (err) throw err
            })
        },
        err => {
            console.log(err)
        }
    )
}

function mkdir(filepath) {
    const arr = filepath.split('/')
    let dir = arr[0]
    for (let i = 1; i < arr.length; i++) {
        if (!fs.existsSync(dir)) { // 如果文件夹不存在则创建文件夹
            fs.mkdir(dir, (err) => {
                if (err) throw err
            })
        }
        dir = dir + '/' + arr[i]
    }
}